"""
Copyright (C) {2015} Texas Instruments Incorporated - http://www.ti.com/ 
ALL RIGHTS RESERVED 
"""

from System.Windows.Media import SolidColorBrush, Color, Colors

from System.Windows.Controls import(ComboBox,ComboBoxItem)
from System.Windows import TextAlignment,FontWeights

import sys
import clr
clr.AddReference("System.Windows.Forms")
from System.Windows.Forms import DialogResult, MessageBox, MessageBoxButtons, MessageBoxIcon

import math


brush_violation = SolidColorBrush(Color.FromArgb(255,204,0,0))
brush_white = SolidColorBrush(Color.FromArgb(255,255,255,255))
brush_alert = SolidColorBrush(Color.FromArgb(255,253,205,52))

text_grey = SolidColorBrush(Color.FromArgb(153,153,153,0))
text_warning = SolidColorBrush(Color.FromArgb(255,204,0,0))
text_black = SolidColorBrush(Colors.Black)
text_white = SolidColorBrush(Color.FromArgb(255,255,255,255))

# Note: In some places elements are accessed using UIC_Control (UI Control Element) because of the clash with controls in User Controls Page

    
class GlobalVariables(object):
	def __init__(self):
		self.VCO_freq_state = "";
g = GlobalVariables();

def System_Update():
    UIC_Fosc_FREQ.TextAlignment = TextAlignment.Right
    UIC_RF_Fpd_FREQ.TextAlignment = TextAlignment.Right
    UIC_RF_Fvco_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_Fpd_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_Fvco_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_N.Foreground = text_white
    UIC_RF_N.Foreground = text_white
    Fosc_FREQ_Update()
    ValidateDiagram()

def System_Update_Loaded_Mode():
    UIC_Fosc_FREQ.TextAlignment = TextAlignment.Right
    UIC_RF_Fpd_FREQ.TextAlignment = TextAlignment.Right
    UIC_RF_Fvco_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_Fpd_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_Fvco_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_N.Foreground = text_white
    UIC_RF_N.Foreground = text_white
    Fosc_FREQ_Update()
    ValidateDiagram()

def System_Update_Run_Once():
    UIC_Fosc_FREQ.TextAlignment = TextAlignment.Right
    UIC_RF_Fpd_FREQ.TextAlignment = TextAlignment.Right
    UIC_RF_Fvco_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_Fpd_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_Fvco_FREQ.TextAlignment = TextAlignment.Right
    UIC_IF_N.Foreground = text_white
    UIC_RF_N.Foreground = text_white
    Fosc_FREQ_Update()
    ValidateDiagram()
    
#   Fosc Update Functions
def Fosc_FREQ_Update():
    RF_Fpd_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/RF_R.iValue,10)
    IF_Fpd_FREQ.dValue = round(Fosc_FREQ.dValue/IF_R.iValue,10)
    RF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/RF_R.iValue*(1.0*flex_RF_N.iValue+RF_FN.iValue*1.0/RF_FD.iValue),10)
    IF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue/IF_R.iValue*flex_IF_N.iValue,10)

def Fosc_FREQ_Update_UI():
    ValidateDiagram()
    
    
#   RF PLL Update Functions
def RF_PD_Update_UI():
    ValidateDiagram() 

def RF_P_Update_UI():
    ValidateDiagram()    

def RF_R_Update():
    RF_Fpd_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/RF_R.iValue,10)
    RF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/RF_R.iValue*(1.0*flex_RF_N.iValue+RF_FN.iValue*1.0/RF_FD.iValue),10)
    
def RF_R_Update_UI():
    ValidateDiagram()    
    
def RF_Fpd_FREQ_Update():
    PLL_R = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)*1.0/RF_Fpd_FREQ.dValue,0)
    RF_Fpd_FREQ.dValue=round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)*1.0/PLL_R,10)
    RF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/PLL_R*(1.0*flex_RF_N.iValue+RF_FN.iValue*1.0/RF_FD.iValue),10)
    
def RF_Fpd_FREQ_Update_UI():
    ValidateDiagram()
    
def RF_FD_Update():
    RF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/RF_R.iValue*(1.0*flex_RF_N.iValue+RF_FN.iValue*1.0/RF_FD.iValue),10)
    
def RF_FD_Update_UI(): 
    ValidateDiagram()
    
def RF_FN_Update():
    RF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/RF_R.iValue*(1.0*flex_RF_N.iValue+RF_FN.iValue*1.0/RF_FD.iValue),10)
    
def RF_FN_Update_UI():
    ValidateDiagram()
    
def flex_RF_N_Update():
    RF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue*(1+OSC_2X.iValue)/RF_R.iValue*(1.0*flex_RF_N.iValue+RF_FN.iValue*1.0/RF_FD.iValue),10)
    
    if (RF_P.iValue==1):
        RF_N.iValue=flex_RF_N.iValue
    else:
        PLL_N = flex_RF_N.iValue
        RF_A= PLL_N % 4
        PLL_N = (PLL_N- RF_A)/4
        RF_B = PLL_N % 4
        PLL_N = (PLL_N-RF_B)/4
        RF_B = RF_B % 2            
        RF_C = PLL_N
        Device=round(SelectedDevice.dValue,0)
        if (Device<2486):
            RF_N.iValue = RF_A + 4*RF_B + 8*(RF_P.iValue+1)*RF_C
        else:
            RF_N.iValue = RF_A + 4*RF_B + 16*(RF_P.iValue+1)*RF_C

def flex_RF_N_Update_UI(): 
    ValidateDiagram()
    
def RF_Fvco_FREQ_Update():
    Fvco = RF_Fvco_FREQ.dValue
    Fpd = RF_Fpd_FREQ.dValue
    PLL_N = Fvco/Fpd
    
    flex_RF_N.iValue=math.floor(PLL_N)
    RF_FN.iValue = round(RF_FD.iValue*(PLL_N-1.0*flex_RF_N.iValue) ,0)   

def RF_Fvco_FREQ_Update_UI():
    ValidateDiagram()
   


#   IF PLL Update Functions
def IF_PD_Update_UI():
    ValidateDiagram() 

def IF_P_Update_UI():
    ValidateDiagram()    

def IF_R_Update():
    IF_Fpd_FREQ.dValue = round(Fosc_FREQ.dValue/IF_R.iValue,10)
    IF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue/IF_R.iValue*flex_IF_N.iValue,0)
    
def IF_R_Update_UI():
    ValidateDiagram()    
    
def IF_Fpd_FREQ_Update():
    PLL_R = round(Fosc_FREQ.dValue/IF_Fpd_FREQ.dValue,0)
    IF_Fpd_FREQ.dValue=round(Fosc_FREQ.dValue/PLL_R,10)
    IF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue/PLL_R*flex_IF_N.iValue,10)
    
def IF_Fpd_FREQ_Update_UI():
    ValidateDiagram()
    
def IF_FD_Update():
    IF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue/IF_R.iValue*flex_IF_N.iValue,10)
    
def IF_FD_Update_UI(): 
    ValidateDiagram()
    
def IF_FN_Update():
    IF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue/IF_R.iValue*flex_IF_N.iValue,10)
    
def IF_FN_Update_UI():
    ValidateDiagram()
    
def flex_IF_N_Update():
    IF_Fvco_FREQ.dValue = round(Fosc_FREQ.dValue/IF_R.iValue*flex_IF_N.iValue,10)
    
    if (IF_P.iValue==1):
        IF_N.iValue=flex_IF_N.iValue
    else:
        PLL_N = flex_IF_N.iValue
        Device = round(SelectedDevice.dValue,0)
        if (Device<2486):
            IF_A = PLL_N % 8
            IF_B = (PLL_N - (PLL_N%16))/16
            IF_N.iValue = IF_A + 8*IF_B
        else:
            IF_A = PLL_N % 16
            IF_B = (PLL_N - (PLL_N%8))/8 
            IF_N.iValue = IF_A + 8*IF_B

def flex_IF_N_Update_UI(): 
    ValidateDiagram()
    
def IF_Fvco_FREQ_Update():
    Fvco = IF_Fvco_FREQ.dValue
    Fpd = IF_Fpd_FREQ.dValue
    PLL_N = Fvco/Fpd
    
    flex_IF_N.iValue=math.floor(PLL_N)
    IF_FN.iValue = round(IF_FD.iValue*(PLL_N-1.0*flex_IF_N.iValue) ,0)   

def IF_Fvco_FREQ_Update_UI():
    ValidateDiagram()
    

def ValidateDiagram():
    Fosc=Fosc_FREQ.dValue
    Fpd =RF_Fpd_FREQ.dValue
    Fvco=RF_Fvco_FREQ.dValue

    #   Validate OSCin
    if (RF_PD.iValue==1) and (IF_PD.iValue==1):
        Dim(Fosc_FREQ)
        UIC_Fosc_FREQ.ToolTip=None  
    elif (Fosc<5):
        UIC_Fosc_FREQ.Background = brush_violation
        UIC_Fosc_FREQ.ToolTip="Minimum Fosc is 5 MHz"
    elif (Fosc>110):
        UIC_Fosc_FREQ.Background = brush_violation
        UIC_Fosc_FREQ.ToolTip="Maximum Fosc is 1000 MHz"
    else:
        UIC_Fosc_FREQ.Background = brush_white
        UIC_Fosc_FREQ.ToolTip=None  
        
    Device=round(SelectedDevice.dValue,0)    
        
    #   Validate RF PLL
    if  (RF_PD.iValue==1):
        #   Dim Everything if Powered Down
        Dim(OSC_2X)
        Dim(DITH)
        Dim(RF_P)
        Dim(RF_CPG)
        Dim(RF_CPP)
        
        Dim(RF_Fvco_FREQ)
        Dim(RF_Fpd_FREQ)
        Dim(RF_R)
        Dim(flex_RF_N)
        Dim(RF_FN)
        Dim(RF_FD)
        Dim(FM)

        UIC_RF_Fvco_FREQ.ToolTip=None
        UIC_RF_Fpd_FREQ.ToolTip=None
        UIC_RF_R.ToolTip=None
        UIC_flex_RF_N.ToolTip=None
        UIC_RF_FN.ToolTip=None
        UIC_RF_FD.ToolTip=None
        UIC_FM.ToolTip=None
        UIC_DITH.ToolTip=None      

    else:
        #   Default as OK until problem is found
        UnDim(OSC_2X)
        UnDim(RF_P)
        UnDim(RF_CPG)
        UnDim(RF_CPP)
        
        UIC_RF_Fvco_FREQ.ToolTip=None
        UIC_RF_Fpd_FREQ.ToolTip=None
        UIC_RF_R.ToolTip=None
        UIC_flex_RF_N.ToolTip=None
        UIC_RF_FN.ToolTip=None
        UIC_RF_FD.ToolTip=None
        UIC_FM.ToolTip=None
        UIC_DITH.ToolTip=None        

        UIC_RF_Fvco_FREQ.Background = brush_white
        UIC_RF_Fpd_FREQ.Background = brush_white
        UIC_RF_R.GetTextBox().Background = brush_white
        UIC_flex_RF_N.GetTextBox().Background = brush_white
        UIC_RF_FN.GetTextBox().Background = brush_white
        UIC_RF_FD.GetTextBox().Background = brush_white
        UIC_FM.Background = brush_white
        UIC_DITH.Background = brush_white 
        
        #   Validate RF Fpd and Fvco
        if (RF_Fpd_FREQ.dValue>50):
            UIC_RF_Fpd_FREQ.Background=brush_violation
            UIC_RF_Fpd_FREQ.ToolTip="Maximum RF phase detector frequency is 50 MHz."
        
        Fmin = -1
        Fmax=-1
                
        if (Device==2483):
            Fmin = 500
            Fmax = 3100
        elif (Device==2484):
            Fmin=50
            Fmax=3000
        elif (Device==2485):
            Fmin = 500
            Fmax=3000
        elif (Device==2486):
            Fmin=1000
            Fmax=4500
        elif (Device == 2487):
            Fmin = 1000
            Fmax = 6000
        else:
            Fmin = 2000
            Fmax = 7500
        
        if (RF_Fvco_FREQ.dValue>Fmax):
            UIC_RF_Fvco_FREQ.Background=brush_violation
            UIC_RF_Fvco_FREQ.ToolTip="Maximum RF VCO frequency is " + str(Fmax)
        elif (RF_Fvco_FREQ.dValue<Fmin):
            UIC_RF_Fvco_FREQ.Background=brush_violation
            UIC_RF_Fvco_FREQ.ToolTip="Minimum RF VCO frequency is " + str(Fmin)   
        
        #   Validate RF Prescaler#    
        if (Device<2486):
            PreMaxFreq=2000
        else:
            PreMaxFreq=4000
        
        if (RF_P.iValue==0):
            if (Device<2486) and (RF_Fvco_FREQ.dValue>2000):
                UIC_RF_P.Background=brush_violation
                UIC_RF_P.ToolTip="Maximum frequency for the 8/9/12/13 prescaler is 2 GHz"
            if (Device>2485) and (RF_Fvco_FREQ.dValue>4000):
                UIC_RF_P.Background=brush_violation
                UIC_RF_P.ToolTip="Maximum frequency for the 16/17/21/21 prescaler is 4 GHz"

        #   Validate RF N Divider Value    
        MinN=-1
        if (Device<2486):
            if (RF_P.iValue==1):
                MinNFloor=49
            else:
                MinNFloor=25
        else:
            if (RF_P.iValue==1):
                MinNFloor=97
            else:
                MinNFloor=49        
            
        PLL_N = flex_RF_N.iValue
        
        if (PLL_N<MinNFloor):
            UIC_flex_RF_N.ToolTip="The minimum N divide for any modulator order is " +str(MinNFloor)
            UIC_flex_RF_N.GetTextBox().Background = brush_violation
        else: 
            if (RF_P.iValue==0):
                if (FM.iValue<3):
                    MinN=25
                elif (FM.iValue==3):
                    MinN=27
                else:
                    MinN=31
            else:
                if (FM.iValue<3):
                    MinN=49
                elif (FM.iValue==3):
                    MinN=51
                else:
                    MinN=55   

            if (PLL_N<MinN):
                UIC_flex_RF_N.ToolTip="This PLL_N value is too low for this FM or Prescaler, but could be accomodated if they are reduced.  For this fractional order and prescaler, the minimum N value is " +str(MinN)
                UIC_flex_RF_N.GetTextBox().Background = brush_alert
                UIC_FM.Background=brush_violation

        #   Validate Fnum       
        if (RF_FN.iValue>0) and (RF_FD.iValue==0): 
            UIC_RF_FN.Background=brush_violation
            UIC_RF_FD.Background=brush_violation    
        
    #   Validate IF PLL        
    if  (IF_PD==1):
        Dim(IF_P)
        Dim(IF_CPP)
        
        Dim(IF_Fvco_FREQ)
        Dim(IF_Fpd_FREQ)
        Dim(IF_R)
        Dim(flex_IF_N)

        UIC_IF_Fvco_FREQ.ToolTip=None
        UIC_IF_Fpd_FREQ.ToolTip=None
        UIC_IF_R.ToolTip=None
        UIC_flex_IF_N.ToolTip=None   
    else:
        #   Default as OK until problem is found
        UnDim(IF_P)
        UnDim(IF_CPP)
        
        UIC_IF_Fvco_FREQ.ToolTip=None
        UIC_IF_Fpd_FREQ.ToolTip=None
        UIC_IF_R.ToolTip=None
        UIC_flex_IF_N.ToolTip=None

        UIC_IF_Fvco_FREQ.Background = brush_white
        UIC_IF_Fpd_FREQ.Background = brush_white
        UIC_IF_R.GetTextBox().Background = brush_white
        UIC_flex_IF_N.GetTextBox().Background = brush_white  
        

        #   Validate IF Fpd and Fvco
        if (IF_Fpd_FREQ.dValue>10):
            UIC_IF_Fpd_FREQ.Background=brush_violation
            UIC_IF_Fpd_FREQ.ToolTip="Maximum IF phase detector frequency is 10 MHz."
            
        if (Device<2486):
            Fmin = 75
            Fmax = 800
        else:
            Fmin = 250
            Fmax = 3000

        if (IF_Fvco_FREQ.dValue>Fmax):
            UIC_IF_Fvco_FREQ.Background=brush_violation
            UIC_IF_Fvco_FREQ.ToolTip="Maximum IF VCO frequency is " + str(Fmax)
        elif (IF_Fvco_FREQ.dValue<Fmin):
            UIC_IF_Fvco_FREQ.Background=brush_violation
            UIC_IF_Fvco_FREQ.ToolTip="Minimum IF VCO frequency is " + str(Fmin)  
            
            
        #   Validate IF Prescaler
        if (Device>2485) and (IF_P.iValue==0) and (IF_Fvco_FREQ.dValue>2000):
                UIC_IF_P.Background=brush_violation
                UIC_IF_P.ToolTip="Maximum frequency for the IF prescaler is 2 GHz"


        #   Validate IF N Divider    
        MinN=-1
            
        PLL_N = flex_IF_N.iValue
        if (IF_P.iValue==0):
            if (PLL_N<23):
                UIC_flex_IF_N.ToolTip="N values below 23 are not premitted."
                UIC_flex_IF_N.GetTextBox().Background = brush_violation  
            elif (PLL_N<56):
                UIC_flex_IF_N.ToolTip="N Value is in the range where divider where not all divides work.  Legal divide ratios in this range are: 24-27,32-36,40-45, 48-54"
                UIC_flex_IF_N.GetTextBox().Background = brush_alert              
        else:
            if (PLL_N<23):
                UIC_flex_IF_N.ToolTip="N values below 23 are not premitted."
                UIC_flex_IF_N.GetTextBox().Background = brush_violation  
            elif (PLL_N<48):
                UIC_flex_IF_N.ToolTip="This 16/17 prescaler can not go down this low, but the 8/9 prescaler can if the N divider value is in the range of 24-27, 32-36, or 40-45."
                UIC_flex_IF_N.GetTextBox().Background = brush_violation                
            elif (PLL_N<240):
                UIC_flex_IF_N.ToolTip="N value is in the range where not all divides are valid.  If value is invalid, also consider using the 8/9 prescaler.  Valid divide ranges are:  48-51- 64-68, 80-85, 96-102, 112-119, 128-136, 144-153, 160-170, 176-187, 192-204, 208-221, 224-238"
                UIC_flex_IF_N.GetTextBox().Background = brush_alert         
 
